<!DOCTYPE html>
<html lang="en">
  <head>
  <meta charset="utf-8" />
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0">

  <title>Learn</title>
  <meta property="og:title" content="Learn" />
  <meta name="twitter:title" content="Learn" />
  <meta name="description" content="Documentation Some brief documentation to start out with.
Tables Create a singleton table
 #value = 1 #name = &quot;Alan Turing&quot;  Create an array
 #vector = [1 2 3]  Create a column array
 #column = [1; 2; 3]  Create a 2D table
 #two-by-three = [1 2 3 4 5 6]  Create a table with named columns
 #with-columns = [|name age height| &quot;Yan&quot; 20 100 &quot;Seth&quot; 23 102]  Create an inline table">
  <meta property="og:description" content="Documentation Some brief documentation to start out with.
Tables Create a singleton table
 #value = 1 #name = &quot;Alan Turing&quot;  Create an array
 #vector = [1 2 3]  Create a column array
 #column = [1; 2; 3]  Create a 2D table
 #two-by-three = [1 2 3 4 5 6]  Create a table with named columns
 #with-columns = [|name age height| &quot;Yan&quot; 20 100 &quot;Seth&quot; 23 102]  Create an inline table">
  <meta name="twitter:description" content="Documentation Some brief documentation to start out with.
Tables Create a singleton table
 #value = 1 #name = &quot;Alan Turing&quot;  Create an array
 #vector = [1 2 3]  Create a column array …">
  <meta name="author" content="Corey Montella"/>
  <link href='https://mech-lang.org/img/favicon.ico' rel='icon' type='image/x-icon'/>
  <meta name="twitter:card" content="summary" />
  <meta property="og:url" content="https://mech-lang.org/page/learn/" />
  <meta property="og:type" content="website" />
  <meta property="og:site_name" content="The Mech Programming Language" />

  <meta name="generator" content="Hugo 0.54.0" />
  <link rel="canonical" href="https://mech-lang.org/page/learn/" />
  <link rel="alternate" href="https://mech-lang.org/index.xml" type="application/rss+xml" title="The Mech Programming Language">
  <link rel="stylesheet" href="https://mech-lang.org/css/main.css"/>
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Lora:400,700,400italic,700italic" />
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Open+Sans:300italic,400italic,600italic,700italic,800italic,400,300,600,700,800" />
  <link rel="stylesheet" href="https://mech-lang.org/css/pygment_highlights.css" />
  <link rel="stylesheet" href="https://mech-lang.org/css/highlight.min.css" />

<script type="application/javascript">
var doNotTrack = false;
if (!doNotTrack) {
	window.ga=window.ga||function(){(ga.q=ga.q||[]).push(arguments)};ga.l=+new Date;
	ga('create', 'UA-120731667-1', 'auto');
	
	ga('send', 'pageview');
}
</script>
<script async src='https://www.google-analytics.com/analytics.js'></script>

</head>

  <body>
    <div class="black-bar">

</div>
<nav class="navbar">

  <div class="navbar-header">
      
        <a class="navbar-brand" href="https://mech-lang.org"><img class="logo-nav" src="https://mech-lang.org/img/logo.png" /></a>
      
  </div>
  <div class="spacer"></div>
  <div class="collapse navbar-collapse" id="main-navbar">
    <ul class="nav navbar-nav navbar-right">
      <li>
        <a title="Community" href="https://mech-lang.org/page/community/">Community</a>
      </li>
      <li>
        <a title="Learn" href="https://mech-lang.org/page/learn/">Learn</a>
      </li>
      <li>
        <a title="Blog" href="https://mech-lang.org/blog/">Blog</a>
      </li>
      <li>
        <a title="Try" href="http://try.mech-lang.org">Try</a>
      </li>
    </ul>
  </div>

</nav>




    
  
  
  




  



    
<div class="container">
  <div class="row">
    <div class="col-lg-8 col-lg-offset-2 col-md-10 col-md-offset-1">
      <div>
      <article role="main" class="blog-post">
        

<h2 class="post-title" id="documentation"># Documentation</h1>

<p>Some brief documentation to start out with.</p>

<h2 id="tables">Tables</h2>

<p>Create a table with a single cell</p>

<pre><code>  #value = 1
  #name = &quot;Alan Turing&quot;
</code></pre>

<p>Create an array</p>

<pre><code>  #vector = [1 2 3]
</code></pre>

<p>Create a column array</p>

<pre><code>  #column = [1; 2; 3]
</code></pre>

<p>Create a 2D table</p>

<pre><code>  #two-by-three = [1 2 3
                   4 5 6]
</code></pre>

<p>Create a table with named columns</p>

<pre><code>  #with-columns = [|name   age height|
                    &quot;Yan&quot;  20  100
                    &quot;Seth&quot; 23  102]
</code></pre>

<p>Create an inline table</p>

<pre><code>  #inline-table = [name: &quot;Yan&quot; age: 20 height: 100]
</code></pre>

<p>Create a nested table</p>

<pre><code>  #nested-table = [type: &quot;div&quot; parameters: [width: 100 height: 50]]
</code></pre>

<h2 id="slicing-tables">Slicing Tables</h2>

<p>Tables are 1-indexed, meaning the first element of the table is at index 1 (not 0 as in C-like languages)</p>

<p>Tables are indexed with the index operator {}. For example, we can get the 3rd element of a vector:</p>

<pre><code>  #slice1 = #vector{3}
</code></pre>

<p>Get the 2nd row, 3rd column:</p>

<pre><code>  #slice2 = #two-by-three{2,3}
</code></pre>

<p>Grab every row or column with the : operator</p>

<pre><code>  #slice3 = #two-by-three{:,3}
</code></pre>

<p>Slice a range of columns</p>

<pre><code>  #slice4 = #two-by-three{1,2:3}
</code></pre>

<p>Access a named column</p>

<pre><code>  #slice5 = #with-columns.height
</code></pre>

<p>Or a specific row of a column</p>

<pre><code>  #slice6 = #with-columns.height{2}
</code></pre>

<p>But you can still use indexes on tables with named columns</p>

<pre><code>  #slice7 = #with-columns{2,3}
</code></pre>

<p>Access the value of a nested table by chaining {} operators</p>

<pre><code>  #slice8 = #nested-table{2}{1}
</code></pre>

<h2 id="math">Math</h2>

<p>Mech identifiers can contain - and / characters, which means math operators aside from negation must have spaces around them.</p>

<p>Math with scalars</p>

<pre><code>  #result1 = 1 + 2
</code></pre>

<p>Math with negation</p>

<pre><code>  #result1 = 1 + -(7 + 2)
</code></pre>

<p>Math with scalar and vector</p>

<pre><code>  x = [1 2 3]
  #result2 = x + 1
</code></pre>

<p>Math with vectors. The operator is applied element-wise</p>

<pre><code>  x = [1 2 3]
  y = [4 5 6]
  #result3 = x + y
</code></pre>

<p>Element-wise operations apply to 2d tables as well</p>

<pre><code>  x = [1 2 3
       4 5 6]
  y = [7 8 9
       6 5 4]
  #result4 = x + y
</code></pre>

<p>Functions use named arguments. The same function can have different arguments depending on the input</p>

<pre><code>  #result5 = math/sin(degrees: 90)
  #result6 = math/sin(radians: 90 * 3.14 / 180)
</code></pre>

<p>The input to a function can be a column. Regular functions operate element-wise on columns, and result in a column</p>

<pre><code>  x = [30; 60; 90; 180; 240; 360]
  #result7 = math/sin(degrees: x)
</code></pre>

<p>Aggregates operate on a column, but the result is a single cell</p>

<pre><code>  x = [30; 60; 90; 180; 240; 360]
  #result8 = stats/sum(column: x)
</code></pre>

      </article>
      

    </div>
  </div>
</div>

    
<script src="https://cdnjs.cloudflare.com/ajax/libs/KaTeX/0.7.1/katex.min.js" integrity="sha384-/y1Nn9+QQAipbNQWU65krzJralCnuOasHncUFXGkdwntGeSvQicrYkiUBwsgUqc1" crossorigin="anonymous"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/KaTeX/0.7.1/contrib/auto-render.min.js" integrity="sha384-dq1/gEHSxPZQ7DdrM82ID4YVol9BYyU7GbWlIwnwyPzotpoc57wDw/guX8EaYGPx" crossorigin="anonymous"></script>
<script src="https://code.jquery.com/jquery-1.12.4.min.js" integrity="sha256-ZosEbRLbNQzLpnKIkEdrPv7lOy9C27hHQ+Xp8a4MxAQ=" crossorigin="anonymous"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js" integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa" crossorigin="anonymous"></script>
<script src="https://mech-lang.org/js/main.js"></script>
<script src="https://mech-lang.org/js/highlight.min.js"></script>
<script> hljs.initHighlightingOnLoad(); </script>
<script> renderMathInElement(document.body); </script>





  </body>
</html>

